/*
 * characterdb.h
 *
 *  Created on: 04-12-2013
 *      Author: crm
 */

#pragma once

#include <string>

#include "gameplay/objecttype.h"

class Character;

namespace CharacterDatabase
	{
	struct Entry
		{
		Entry(): crc(0u), path() {}
		Entry(const Entry& c): crc(c.crc), path(c.path) {}

		unsigned crc;						// CRC32 resfile
		std::string path;					// Aktualna sciezka do resfile
		};

	void init(const std::string& path);
	void clear();

	bool add(const std::string& path);
	bool add(unsigned crc, unsigned size, char *data);

	bool load(const std::string& path);		// Wczytanie listy postaci, sciezka do pliku database'a
	bool save(const std::string& path);		// Zapisanie ^

	const Entry* getByCRC(unsigned crc);
	const Entry* getByPath(const std::string& path);

	Character* createByCRC(unsigned crc, ObjectType::Type type=ObjectType::OBJECT_LOCAL);
	Character* createByPath(const std::string& path, ObjectType::Type type=ObjectType::OBJECT_LOCAL);
	}
