/*
 * combo.cpp
 *
 *  Created on: 23-08-2013
 *      Author: crm
 */

#include "combomanager.h"

#include <cstdio>

#include "clock.h"

#define EVENTS_EQUAL(a, b) (((a)&(b)) || ((a)==0 && (b)==0))

//void ComboManager::update(const std::list<Event>& events)
int ComboManager::update()
	{
	if(!need_update)
		return 0;
	need_update=false;

	if(events.size()<1u)
		return 0;

	for(std::vector<Combo>::iterator it=combos.begin(); it!=combos.end(); ++it)
		{
		if(it->hasMatch(events))
			{
			events.clear();

			return it->getRef();
			}
		}

	return 0;
	}

void ComboManager::pushEvent(const Event& e)
	{
	//const int TIME_BETWEEN_EVENTS=400;
	const int EVENT_MAX_DURATION=500;

	if(events.size()>0)
		{
		Event& eb=events.back();

		//if(eb.event!=Event::NONE)
			events.back().stop=Clock::getTimeMilis();
		if(eb.event==e.event)
			return;
		//if(eb.stop+TIME_BETWEEN_EVENTS<Clock::getTimeMilis())
		//	events.clear();
		if(eb.stop-eb.start>EVENT_MAX_DURATION)
			events.clear();
		}

	if(e.event!=0)	// Nie wrzucaj none'ow
		events.push_back(e);
	need_update=true;
	}

bool ComboManager::Combo::hasMatch(const std::list<Event>& events)
	{
	std::list<Event>::const_iterator beg;					// Poczatek aktualnego matcha
	std::list<Event>::const_iterator cur;					// Aktualna pozycja
	std::vector<int>::const_iterator it;					// Aktualnie sprawdzany element combosa

	beg=events.begin();
	cur=events.begin();
	it=combo.begin();

	while(true)
		{
		//printf("it: %s; cur: %s;\n", getEventNameCharacter(*it).c_str(), getEventNameCharacter(cur->event).c_str());

		//if(cur->event&*it)									// Sprawdz czy lapiemy sie na kolejny element combosa
		if(EVENTS_EQUAL(cur->event, *it))
			{
			if(it==combo.begin())							// Jesli to poczatek combosa, zapisz skad zaczynamy
				beg=cur;

			++it;
			++cur;
			}
		//else if(it!=combo.begin() && (cur->event&*(it-1)))	// Sprawdz czy poprzednia akcja sie powtarzala
		else if(it!=combo.begin() && EVENTS_EQUAL(cur->event, *it))
			{
			++cur;
			}
		else												// Pudlo
			{
			if(beg!=events.end())							// Wroc do poczatku
				{
				cur=beg;
				beg=events.end();
				it=combo.begin();
				}

			++cur;
			}

		if(it==combo.end())									// Combo trafione, radujmy sie
			{
			//events.erase(events.begin(), cur);			// Dopoki mam const liste to tego nie zrobie
			return true;
			}
		if(cur==events.end())								// Nawet jesli bylo blisko, zabraklo eventow - pudlo
			break;
		}

	return false;
	}
