/*
 * effect.h
 *
 *  Created on: 19-07-2013
 *      Author: crm
 */

#pragma once

#include <ctime>
#include <string>

#include "graphics/spriteptr.h"

class Effect
	{
	protected:
		Graphics::SpritePtr spr;

		//int start;
		//int timeout;
		float start, timeout;

	public:
		Effect(): spr(), start(0.0f), timeout(0.0f) {}
		virtual ~Effect() {clear();}

		virtual void init(const std::string& name, int ms);
		virtual void update(float dt) {timeout-=dt;}
		virtual void print()=0;
		virtual void clear();

		virtual bool finished() const {return timeout<=0.0f;}

		//inline void setPos(AVector pos) {mov->setPos(pos);}
		inline void setSprite(const std::string& name) {spr.setSprite(name);}
		inline void setTimeout(int stimeout) {start=stimeout/1000.0f; timeout=start;}

		//inline AVector getPos() const {return pos;}
		inline float getPct() const {return 1.0f-(timeout/start);}
	};
