/*
 * gameobject.h
 *
 *  Created on: 12 kwi 2015
 *      Author: crm
 */

#pragma once

#include "asmmath.h"

#include "base/eventprovider.h"
#include "base/serializable.h"
#include "colliders/box.h"

namespace Gameplay
	{
	class GameObject: public EventProvider, public Serializable
		{
		public:
			enum Type
				{
				NONE=0,
				CHARACTER,
				IDEA,
				};

		protected:
			unsigned id;

			AVector pos;
			AVector spd;

			Box collider;

		public:
			GameObject(): id(0), pos(), spd() {}
			GameObject(const GameObject& go): id(go.id), pos(go.pos), spd(go.spd), collider(go.collider) {}
			virtual ~GameObject();

			virtual void update(float dt)=0;
			virtual void print()=0;
			virtual void clear();

			//virtual char* serialize(int &size)=0;
			//virtual void deserialize(char *buff)=0;

			virtual Type getType() const {return NONE;}

			// Te, ktorych nie trzeba nadpisywac w klasach pochodnych
			unsigned getID() const {return id;}
			AVector getPosition() const {return pos;}
			AVector getSpeed() const {return spd;}

			void setID(unsigned s) {id=s;}
			void setPosition(const AVector& s) {pos=s;}
			void setSpeed(const AVector& s) {spd=s;}
		};
	}
