/*
 * Idea.cpp
 *
 *  Created on: 05-10-2014
 *      Author: crm
 */

#include "idea.h"

#include "log.h"

#include "render.h"

#include "base/gamemode.h"
#include "character.h"
#include "arena.h"

int Idea::nextid=0;

bool Idea::init(const std::string& name, float sdamage, float scost, GameMode* sgamemode, float srestitution, Character* sparent)
	{
	spr.setSprite(name);

	id=++nextid;

	damage=sdamage;
	restitution=srestitution;

	cost=scost;

	owner=sparent;
	gamemode=sgamemode;

	return 0;
	}

void Idea::update(float dt)
	{
	spr.update(dt);

	if(owner)
		return;

	AVector vdt=AVectorReplicate(dt);
	Arena *arena=gamemode->getArena();

	//if(!arena->getCollision(pos, AVectorMultiply(GRAVITY, vdt)))
	if(pos.z>0.0f)	// ^ olac dobre praktyki, poki co chce, zeby to dzialalo :F
		//spd=AVectorAdd(spd, AVectorMultiply(GRAVITY, vdt));
		spd.z+=arena->getGravity().z*dt;
	else
		{
		spd.x-=spd.x*2.5f*dt;
		spd.y-=spd.y*2.5f*dt;
		}

	AVector spddt=AVectorMultiply(spd, vdt);

	/*if(arena->getCollision(pos, spddt))
		{
		const AVector spddtx=AVectorSet(spddt.x, 0.0f, 0.0f, 0.0f);
		const AVector spddty=AVectorSet(0.0f, spddt.y, 0.0f, 0.0f);
		const AVector spddtz=AVectorSet(0.0f, 0.0f, spddt.z, 0.0f);

		if(arena->getCollision(pos, spddtx))	 spddt.x=arena->getCollisionDist(pos, spddtx);
		if(arena->getCollision(pos, spddty))	 spddt.y=arena->getCollisionDist(pos, spddty);
		if(arena->getCollision(pos, spddtz))
			{
			spddt.z=-arena->getCollisionDist(pos, spddtz);

			if(spd.z<arena->getGravity().z*0.3f)
				spd.z*=-0.25f;
			else
				spd.z = 0.0f;
			}
		}*/

	pos=AVectorAdd(pos, spddt);
	}

void Idea::print()
	{
	if(objtype==OBJECT_HEADLESS)
		return;

	//Render::print(spr, Orientation(pos, AVector(0, 0, 1), AVector(0, 1, 0)));
	Render::print(spr, Orientation(pos, Render::getCamera()->getUp(), -Render::getCamera()->getForward()));
	}

void Idea::clear()
	{
	//
	}


char* Idea::serialize(int &size)
	{
	size=0;
	return NULL;
	}

void Idea::deserialize(char *buff)
	{
	//
	}


Idea* Idea::clone() const
	{
	Idea *i;

	try
		{
		i=new Idea();
		}
	catch(std::bad_alloc&)
		{
		Log::fail("Idea.clone: Nie udalo sie stworzyc pomyslu");
		return NULL;
		}

	i->spr.setSprite(spr);

	i->damage=damage;
	i->restitution=restitution;

	return i;
	}


/*void pushEvent(unsigned e, float dataf=0.0f, int datai)
	{
	//
	}

void pushEvent(const Event& e)
	{
	//
	}*/

