/*
 * packet_dialogi.h
 *
 *  Created on: 21-08-2013
 *      Author: crm
 */

#pragma once

//#include "asmmath.h"

namespace Network
	{
	enum PacketType
		{
		CLIENT_PING=			   -1,	// Klasy klienta i serwera same sie nimi zajmuja, wiec jest tu tylko dla formalnosci
		SERVER_PING=				0,	// ^

		WELCOME,
		WELCOME_RESPONSE,
		BYE,

		INFO_CHARACTER,
		INFO_SERVER,
		INFO_ARENA,
		//INFO_IDEA,

		CHARACTER_ADD,
		CHARACTER_DEL,

		STATE_CHARACTER,
		//STATE_ARENA,
		STATE_GAMEMODE,

		EVENT_CONTROLLER,
		EVENT_CHARACTER,
		EVENT_GAMEMODE,

		MISC_PLAY_SOUND,
		MISC_PLAY_MUSIC,

		REQUEST,

		DATA_INFO,
		DATA,
		};

	struct Welcome
		{
		int pid;						// Identyfikator gracza, -1 jesli nie ma zadnego, dowolny inny jesli jakis ma
		};								// Serwer zwraca nowy lub przeslany w tej strukturze jako WELCOME_RESPONSE

	struct InfoCharacter
		{
		int cid;						// Ktorego gracza jest to postac, jesli przesyla klient i pid!=jego pid - olej pakiet
		unsigned crc;
		//char path[1];					// Sciezka do pliku postaci
		};

	struct InfoServer
		{
		int gamemode;					// Typ uzywanego gamemode
		};

	struct InfoArena
		{
		unsigned crc;
		//char path[1];					// Sciezka do pliku areny
		};

	struct AddDelCharacter
		{
		int cid;						// Numer postaci (ten sam co w infocharacter) ktora sie pojawila lub zniknela
		int pid;						// Wysylane przy player_connect jak i disconnect
		};

	struct State
		{
		int id;							// ID obiektu, jesli dotyczy
		//int size;						// Dlugosc danych pod data
		char data[1];					// State'y sa jako serializowane dane, wiec tylko tyle chyba potrzeba.
		};

	 struct ControllerState
		{
		enum
			{
			UP=			0x1<<0,
			DOWN=		0x1<<1,
			LEFT=		0x1<<2,
			RIGHT=		0x1<<3,
			A=			0x1<<4,
			B=			0x1<<5,
			};

		int keys;
		};

	struct EventCharacter
		{
		int id;
		unsigned state;
		float x, y, z;
		float spdx, spdy, spdz;
		float hp, air;
		int event;
		int datai;
		float dataf;
		};

	struct Request
		{
		enum Type
			{
			CHARACTER,
			ARENA,
			};

		Type type;
		unsigned crc;
		};

	struct DataInfo
		{
		unsigned size;			// Wielkosc calkowita
		};

	struct Data
		{
		static const unsigned DATA_SIZE=1024;

		unsigned part;			// Ktora czesc danych
		unsigned size;			// Wielkosc danych (od 0 do sizeof(data)
		char data[DATA_SIZE];	// Dane
		};
	}
