/*
 * transferrer.h
 *
 *  Created on: 26-12-2013
 *      Author: crm
 */

#pragma once

#include <list>
#include <string>

#include "packet.h"
#include "packet_dialogi.h"

namespace Network
	{
	class SocketClient;

	class Transferrer
		{
		private:
			class Transfer
				{
				std::string file;

				Request::Type type;

				unsigned crc;
				unsigned size;
				char *data;

				unsigned id;
				unsigned parts;
				};

			class Upload: public Transfer
				{
				unsigned part;
				};

			class Download: public Transfer
				{
				unsigned recvd;
				bool *recvdparts;
				};

			SocketClient *sock;

			std::list<Upload> uploads;
			std::list<Download> downloads;

		public:
			Transferrer(): sock(NULL) {}
			~Transferrer() {clear();}

			void init(SocketClient *sock);
			void update();
			void clear();

			void parse(Packet *pack);

			void upload(Request::Type type, unsigned crc);
			void download(Request::Type type, unsigned crc);
		};
	}
