/*
 * demomenu.cpp
 *
 *  Created on: 25-09-2013
 *      Author: crm
 */

#include "demomenu.h"

#include <sstream>

#include "log.h"
#include "ini.h"
#include "databasemanager.h"

#include "render.h"

#include "gameengine.h"

enum Actions
	{
	NONE,

	OPTION_HOST,
	OPTION_JOIN,
	OPTION_HELP,
	OPTION_EXIT,
	OPTION_HOST_PLAYERS,
	OPTION_HOST_BOTS,
	OPTION_HOST_START,
	OPTION_HOST_EXIT,
	OPTION_JOIN_IP,
	OPTION_JOIN_IP_A,
	OPTION_JOIN_IP_B,
	OPTION_JOIN_IP_C,
	OPTION_JOIN_IP_D,
	OPTION_JOIN_IP_EXIT,
	OPTION_JOIN_PLAYERS,
	OPTION_JOIN_START,
	OPTION_JOIN_EXIT,
	};

void DemoMenu::init()
	{
	Ini lang;
	lang.open("lang.ini", "demo_menu");

	Database& db=DatabaseManager::getDatabase("config.nvo");

	m.clear();
	m.init();
	m.getRootLayer()->addOption( new Menu::Option(OPTION_HOST, Menu::ENTER, lang.get("host")) );
		m.getOptionByTag(OPTION_HOST)->initSubLayer(new Menu::Layer());
		m.getOptionByTag(OPTION_HOST)->getSubLayer()->addOption( new Menu::Option(OPTION_HOST_PLAYERS, Menu::VALUE, lang.get("host_players")) );
			m.getOptionByTag(OPTION_HOST_PLAYERS)->initValue(1, 2, 1);
			m.getOptionByTag(OPTION_HOST_PLAYERS)->setVal(1);
		m.getOptionByTag(OPTION_HOST)->getSubLayer()->addOption( new Menu::Option(OPTION_HOST_BOTS, Menu::VALUE, lang.get("host_bots")) );
			m.getOptionByTag(OPTION_HOST_BOTS)->initValue(0, 32, 1);
			m.getOptionByTag(OPTION_HOST_BOTS)->setVal(0);
		m.getOptionByTag(OPTION_HOST)->getSubLayer()->addOption( new Menu::Option(OPTION_HOST_START, Menu::ACTION, lang.get("host_start")) );
		m.getOptionByTag(OPTION_HOST)->getSubLayer()->addOption( new Menu::Option(OPTION_HOST_EXIT, Menu::RETURN, lang.get("host_exit")) );
	m.getRootLayer()->addOption( new Menu::Option(OPTION_JOIN, Menu::ENTER, lang.get("join")) );
		m.getOptionByTag(OPTION_JOIN)->initSubLayer(new Menu::Layer());
		m.getOptionByTag(OPTION_JOIN)->getSubLayer()->addOption( new Menu::Option(OPTION_JOIN_IP, Menu::ENTER, lang.get("join_ip")) );
			m.getOptionByTag(OPTION_JOIN_IP)->initSubLayer(new Menu::Layer());
			m.getOptionByTag(OPTION_JOIN_IP)->getSubLayer()->addOption( new Menu::Option(OPTION_JOIN_IP_A, Menu::VALUE, lang.get("join_ip_a")) );
				m.getOptionByTag(OPTION_JOIN_IP_A)->initValue(0, 255, 1);
				m.getOptionByTag(OPTION_JOIN_IP_A)->setVal(db.getVal("demo_join_a"));
				m.getOptionByTag(OPTION_JOIN_IP_A)->setBlock(0.05f);
			m.getOptionByTag(OPTION_JOIN_IP)->getSubLayer()->addOption( new Menu::Option(OPTION_JOIN_IP_B, Menu::VALUE, lang.get("join_ip_b")) );
				m.getOptionByTag(OPTION_JOIN_IP_B)->initValue(0, 255, 1);
				m.getOptionByTag(OPTION_JOIN_IP_B)->setVal(db.getVal("demo_join_b"));
				m.getOptionByTag(OPTION_JOIN_IP_B)->setBlock(0.05f);
			m.getOptionByTag(OPTION_JOIN_IP)->getSubLayer()->addOption( new Menu::Option(OPTION_JOIN_IP_C, Menu::VALUE, lang.get("join_ip_c")) );
				m.getOptionByTag(OPTION_JOIN_IP_C)->initValue(0, 255, 1);
				m.getOptionByTag(OPTION_JOIN_IP_C)->setVal(db.getVal("demo_join_c"));
				m.getOptionByTag(OPTION_JOIN_IP_C)->setBlock(0.05f);
			m.getOptionByTag(OPTION_JOIN_IP)->getSubLayer()->addOption( new Menu::Option(OPTION_JOIN_IP_D, Menu::VALUE, lang.get("join_ip_d")) );
				m.getOptionByTag(OPTION_JOIN_IP_D)->initValue(0, 255, 1);
				m.getOptionByTag(OPTION_JOIN_IP_D)->setVal(db.getVal("demo_join_d"));
				m.getOptionByTag(OPTION_JOIN_IP_D)->setBlock(0.05f);
			m.getOptionByTag(OPTION_JOIN_IP)->getSubLayer()->addOption( new Menu::Option(OPTION_JOIN_IP_EXIT, Menu::RETURN, lang.get("join_exit")) );
		m.getOptionByTag(OPTION_JOIN)->getSubLayer()->addOption( new Menu::Option(OPTION_JOIN_PLAYERS, Menu::VALUE, lang.get("join_players")) );
			m.getOptionByTag(OPTION_JOIN_PLAYERS)->initValue(1, 2, 1);
			m.getOptionByTag(OPTION_JOIN_PLAYERS)->setVal(1);
		m.getOptionByTag(OPTION_JOIN)->getSubLayer()->addOption( new Menu::Option(OPTION_JOIN_START, Menu::ACTION, lang.get("join_start")) );
		m.getOptionByTag(OPTION_JOIN)->getSubLayer()->addOption( new Menu::Option(OPTION_JOIN_EXIT, Menu::RETURN, lang.get("join_exit")) );
	//m.getRootLayer()->addOption( new Menu::Option(OPTION_HELP, Menu::ENTER, lang.get("help")) );
	m.getRootLayer()->addOption( new Menu::Option(OPTION_EXIT, Menu::RETURN, lang.get("exit")) );
	m.block(10.0f);

	//m.print();
	str.init("font/font_02.xml", "", Render::getWindowSize().x, Render::getWindowSize().y);
	str.setAlignCenter();
	str.setAlignMiddle();
	str.setWrapOff();

	spr.setSprite("bg.jpg");

	redraw();
	}

void DemoMenu::update(float dt)
	{
	/**** Sterowanie ****/
	if(!m.isBlocked())
		m.update(dt);
	if(m.needRedraw())
		redraw();

	/**** Akcje ****/
	if(m.isExited())
		{
		GameEngine::popState();
		//GameEngine::stop();
		return;
		}
	if(m.isBlocked())
		{
		switch(m.getOption()->getTag())
			{
			case OPTION_HOST_START:
				{
				//DemoServer *ds=new DemoServer();

				//ds->init(m.getOptionByTag(OPTION_HOST_PLAYERS)->getVal(), m.getOptionByTag(OPTION_HOST_BOTS)->getVal());

				//GameEngine::pushState(ds);
				}
			break;

			case OPTION_JOIN_START:
				{
				int a, b, c, d;

				a=m.getOptionByTag(OPTION_JOIN_IP_A)->getVal();
				b=m.getOptionByTag(OPTION_JOIN_IP_B)->getVal();
				c=m.getOptionByTag(OPTION_JOIN_IP_C)->getVal();
				d=m.getOptionByTag(OPTION_JOIN_IP_D)->getVal();

				Database& db=DatabaseManager::getDatabase("config.nvo");

				db.setVal("demo_join_a", a);
				db.setVal("demo_join_b", b);
				db.setVal("demo_join_c", c);
				db.setVal("demo_join_d", d);
				db.save("config.nvo");

				std::stringstream ss;

				ss << a << "." << b << "." << c << "." << d;

				//DemoClient *dc=new DemoClient();

				//dc->init(m.getOptionByTag(OPTION_JOIN_PLAYERS)->getVal(), ss.str());

				//GameEngine::pushState(dc);
				}
			break;

			default:
				//
			break;
			}
		}
	}

void DemoMenu::print()
	{
	Render::print(spr, Orientation(AVector(0, 0, 0)));
	str.print(Orientation(AVector(0.0f, 0.0f, 0.0f)), 1.0f);
	}

void DemoMenu::clear()
	{
	m.clear();
	}


void DemoMenu::pause()
	{
	//
	}

void DemoMenu::resume()
	{
	m.unlock();
	m.block(10.0f);
	}


void DemoMenu::redraw()
	{
	std::stringstream ss;

	const int size=m.getLayer()->getOptionCount();

	for(int i=0; i<size; ++i)
		{
		Menu::Option *opt=m.getLayer()->getOption(i);

		if(i>0)
			ss << '\n';

		const bool cur=m.getOption()==opt;

		if(cur) ss << '[';
		ss << opt->getName();
		if(opt->getType()==Menu::VALUE)
			ss << ": " << opt->getVal();
		if(cur) ss << ']';
		}

	str.setStr(ss.str());
	str.update();
	}
