/*
 * buffer.h
 *
 *  Created on: 11-02-2013
 *      Author: crm
 */

#pragma once

#include <vector>

#include "vertex.h"
#include "graphics/spriteptr.h"

//class Image;
class Orientation;

namespace Render
	{
	class Buffer
		{
		protected:
			unsigned id;
			unsigned count;

			bool initd;

			std::vector<Vertex> verts;

		public:
			Buffer(): id(0u), count(0u), initd(false) {}
			virtual ~Buffer() {clear();};

			virtual bool init();
			virtual void clear();
			virtual void flush();

			virtual void bind() const=0;

			unsigned getId() const {return id;}
			unsigned getCount() const {return count;}
			bool isEmpty() const {return verts.empty();}
			const Vertex* getVerts() const {return verts.data();}
		};

	class Buffer2D: public Buffer
		{
		private:
			Graphics::SpritePtr spr;

		public:
			Buffer2D(): Buffer()/*, spr()*/ {}

			virtual void clear();

			virtual void bind() const;

			void setSpr(Graphics::SpritePtr& spr);

			void print(const Orientation& orientation, float x, float y, float w, float h, float alpha=1.0f);
			void print(const Orientation& orientation, float alpha=1.0f);
			void print(const Orientation& orientation, unsigned animation, unsigned direction, unsigned frame, float alpha=1.0f);
		};
	}

