/*
 * render_print.cpp
 *
 *  Created on: 01-06-2014
 *      Author: crm
 */

#include "render.h"

#include <SDL/SDL.h>
#include <GL/glee.h>

#include "graphics/image.h"
#include "graphics/sprite.h"

#include "render.h"

#ifdef BLA_BLA_BLA

/**** Printy wszelkiego typu ****/
namespace Render
	{
	// Tutaj rowniez, testy wydajnosci~
	//						   czas    wywolan    czas na jedna
	// print img			t 10000 c 114454684 ps 0.000087
	// print img			t 10000 c 115776508 ps 0.000086
	// print unsigned		t 10000 c  55695923 ps 0.000180
	// print unsigned		t 10000 c  50982031 ps 0.000196
	// print spr			t 10000 c  28512398 ps 0.000351
	// print spr			t 10000 c  27535939 ps 0.000363
	// print sprptr*		t 10000 c  22578547 ps 0.000443
	// print sprptr*		t 10000 c  21999264 ps 0.000455
	// print sprptr&		t 10000 c  22048231 ps 0.000454
	// print sprptr&		t 10000 c  21528233 ps 0.000465
	// Poki jest wiecej niz 10000... nie ma z niczym problemu. Chyba. Zreszta, i tak jest to zawyzona liczba.
	// Pewnie w najlepszym momencie bede uzywal jakies 1000 printow na sekunde~

	void print( float x, float y, float z, int ix, int iy, int iw, int ih, float scale, float ang, float rx, float ry)
		{
		//
		}

	void print(const Graphics::Image *img, float x, float y, float z, int ix, int iy, int iw, int ih, float alpha, float scale, float ang, float rx, float ry)
		{
		bind(img->tex[0]);

		cam->update();

		verts.clear();

		glPushMatrix();

		if(mode&DRAW_BILLBOARD)
			{
			// Billboardyzacja po wektorze 'up' - obiekty moga chowac sie za innymi
			/*const AVector r=cam->getRight();
			const AVector u=cam->getUp();
			verts.push_back( Vertex( 0.0f,			0.0f,			0.0f,	(float) ix/img->w,		(float)(iy+ih)/img->h,	color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );
			verts.push_back( Vertex( iw*r.x,		iw*r.y,			0.0f,	(float)(ix+iw)/img->w,	(float)(iy+ih)/img->h,	color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );
			verts.push_back( Vertex( iw*r.x+ih*u.x,	iw*r.y+ih*u.y,	ih*u.z,	(float)(ix+iw)/img->w,	(float)iy/img->h,		color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );
			verts.push_back( Vertex(        ih*u.x,        ih*u.y,	ih*u.z,	(float) ix/img->w,		(float)iy/img->h,		color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );*/

			if(mode&DRAW_3D)
				{
				// Billboardyzacja ot tak
				const AVector u(0, 0, 1);
				const AVector d=AVectorSubtract(AVector(x, y, z), cam->getPos());
				const AVector r=AVectorNormalize(AVectorCross(d, u));

				verts.push_back( Vertex( 0.0f,		0.0f,	0.0f,	(float) ix/img->w,		(float)(iy+ih)/img->h,		color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );
				verts.push_back( Vertex( iw*r.x,	iw*r.y,	0.0f,	(float)(ix+iw)/img->w,	(float)(iy+ih)/img->h,		color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );
				verts.push_back( Vertex( iw*r.x,	iw*r.y,	ih,		(float)(ix+iw)/img->w,	(float)iy/img->h,			color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );
				verts.push_back( Vertex( 0.0f,		0.0f,	ih,		(float) ix/img->w,		(float)iy/img->h,			color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );

				glTranslatef(x, y, z);
				glTranslatef(-r.x*rx, -r.y*rx, u.z*(ry-ih));
				glRotatef(ang, 0.0f, 0.0f, 1.0f);
				glScalef(scale, scale, scale);
				}
			else
				{
				// Billboardyzacja przez skalowanie
				const AVector r=cam->getRight();
				const AVector u=cam->getUp();

				float ce;
				ce=AVectorDot(u, AVector(0, 0, 1)).x;

				if(ce<0.1f && ce>-0.1f)
					return;

				verts.push_back( Vertex( 0.0f,		0.0f,	0.0f,	(float) ix/img->w,		(float)(iy+ih)/img->h,		color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );
				verts.push_back( Vertex( iw*r.x,	iw*r.y,	0.0f,	(float)(ix+iw)/img->w,	(float)(iy+ih)/img->h,		color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );
				verts.push_back( Vertex( iw*r.x,	iw*r.y,	ih/ce,	(float)(ix+iw)/img->w,	(float)iy/img->h,			color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );
				verts.push_back( Vertex( 0.0f,		0.0f,	ih/ce,	(float) ix/img->w,		(float)iy/img->h,			color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );

				glTranslatef(x, y, z);
				glTranslatef(-r.x*rx, -r.y*rx, u.z*(ry-ih));
				glRotatef(ang, 0.0f, 0.0f, 1.0f);
				glScalef(scale, scale, scale);
				}
			}
		else
			{
			verts.push_back( Vertex( 0.0f, 0.0f, 0.0f,	(float) ix/img->w,		(float)iy/img->h,		color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );
			verts.push_back( Vertex( iw,   0.0f, 0.0f,	(float)(ix+iw)/img->w,	(float)iy/img->h,		color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );
			verts.push_back( Vertex( iw,   ih,   0.0f,	(float)(ix+iw)/img->w,	(float)(iy+ih)/img->h,	color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );
			verts.push_back( Vertex( 0.0f, ih,   0.0f,	(float) ix/img->w,		(float)(iy+ih)/img->h,	color[ALPHA]*alpha, color[RED], color[GREEN], color[BLUE]) );

			glRotatef(ang, 0.0f, 0.0f, 1.0f);
			glScalef(scale, scale, scale);
			glTranslatef(x, y, z);
			glTranslatef(-rx, -ry, 0.0f);
			}

		glVertexPointer		(3, GL_FLOAT,			sizeof(Vertex),	&verts[0].x);
		glTexCoordPointer	(2, GL_FLOAT,			sizeof(Vertex),	&verts[0].tx);
		glColorPointer		(4, GL_UNSIGNED_BYTE,	sizeof(Vertex),	&verts[0].col);
		glDrawArrays(GL_QUADS, 0, verts.size());

		glPopMatrix();

		++fcount;
		}

	void print(const Graphics::Image *img, float x, float y, float z, float alpha, float scale, float ang, float rx, float ry)	// do Image'owego
		{
		print(img, x, y, z, 0, 0, img->w, img->h, alpha, scale, ang, rx, ry);
		}

	void print(const Graphics::Sprite *spr, float x, float y, float z, unsigned anim, unsigned dir, unsigned frame, float alpha, float scale, float ang)	// do Image'owego
		{
		const Graphics::Animation& a=spr->getAnim(anim);
		const Graphics::Direction& d=a.getDir((Graphics::Directions)dir);
		const Graphics::Frame& f=d.getFrame(frame);
		const Graphics::Image *img=spr->getImg();

		print(img, x, y, z, f.x, f.y, f.w, f.h, alpha, scale, ang, f.spotx, f.spoty);
		}

	void print( const Graphics::SpritePtr& sptr, float x, float y, float z)
		{
		const Graphics::Sprite *spr=sptr.getSprite();
		//const Graphics::Animation *a=sptr->getAnim();//spr->getAnim(sptr.getAnim());
		const Graphics::Direction *d=sptr.getDir();//a.getDir((Graphics::Directions)sptr.getDir());
		const Graphics::Frame& f=d->getFrame(sptr.getFrame());
		const Graphics::Image *img=spr->getImg();
		//print(img, x-f.spotx, y-f.spoty, z, f.x, f.y, f.w, f.h, ang, f.spotx, f.spoty);

		print(img, x, y, z, f.x, f.y, f.w, f.h, sptr.getAlpha(), sptr.getScale(), sptr.getAngle(), f.spotx, f.spoty);
		}

	/*void print(Buffer& buff, float x, float y, float z, float scale, float alpha)	// Do Buff'owego
		{
		buff.bind();

		glPushMatrix();
		glMatrixMode(GL_MODELVIEW);

		glTranslatef(x, y, z);
		glColor4f(1.0f, 1.0f, 1.0f, alpha);

//		for(unsigned i=0; i<buff.getCount(); ++i)
//			buff.getVerts()[i].col;

		// Mocno naciagany fragment kodu~
		if(mode&DRAW_BILLBOARD)	// Billboardyzacja
			{
			glTranslatef(x, y, z);
			//glRotatef(-cam->ang,  0.0f, 0.0f, 1.0f);
			//glRotatef(-cam->elev, 1.0f, 0.0f, 0.0f);
			glTranslatef(-x, -y, 0.0f);
			}
		// ^

		print(buff);

		glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
		glPopMatrix();
		}*/

	/*void print(Model& mdl, float x, float y, float z, float rx, float ry, float rz, float alpha, float scale)	// Do Buff'owego
		{
		Buffer& buff=mdl.getBuff();

		flush();
		buff.bind();

		glPushMatrix();
		glMatrixMode(GL_MODELVIEW);

		glTranslatef(x, y, z);
		glRotatef(rx, 1.0f, 0.0f, 0.0f);
		glRotatef(ry, 0.0f, 1.0f, 0.0f);
		glRotatef(rz, 0.0f, 0.0f, 1.0f);
		glScalef(scale, scale, scale);
		glColor4f(color[RED]/255.0f, color[GREEN]/255.0f, color[BLUE]/255.0f, color[ALPHA]/255.0f * alpha/255.0f);

		glDisableClientState(GL_COLOR_ARRAY);	// Bo alfa nie bangla >:

		print(buff);

		glEnableClientState(GL_COLOR_ARRAY);

		//glColor4f(color[RED], color[GREEN], color[BLUE], color[ALPHA]);
		//glDisable(GL_DEPTH_TEST);

		glPopMatrix();
		}

	void print(ModelPtr& mdl, float x, float y, float z, float rx, float ry, float rz, float alpha, float scale)
		{
		print(**mdl, x, y, z, rx, ry, rz, alpha, scale);
		}*/

	void print(Buffer& buff)
		{
		if(buff.getId())
			{
			glBindBuffer(GL_ARRAY_BUFFER, buff.getId());

			if(!buff.isEmpty())
				{
				//Log::ok("Render.print: Wysylanie danych, buff %u, count %u", buff.getId(), buff.getCount());
				glBufferData(GL_ARRAY_BUFFER, buff.getCount()*sizeof(Vertex), buff.getVerts(), GL_STATIC_DRAW);
				buff.flush();
				}

			glVertexPointer		(3, GL_FLOAT,			sizeof(Vertex),		(void *)offsetof(Vertex, x));
			glTexCoordPointer	(2, GL_FLOAT,			sizeof(Vertex),		(void *)offsetof(Vertex, tx));
			glColorPointer		(4, GL_UNSIGNED_BYTE,	sizeof(Vertex),		(void *)offsetof(Vertex, col));

			glDrawArrays(GL_QUADS, 0, buff.getCount());
			glBindBuffer(GL_ARRAY_BUFFER, 0);
			}
		else
			{
			glVertexPointer		(3, GL_FLOAT,			sizeof(Vertex),	&buff.getVerts()->x);
			glTexCoordPointer	(2, GL_FLOAT,			sizeof(Vertex),	&buff.getVerts()->tx);
			glColorPointer		(4, GL_UNSIGNED_BYTE,	sizeof(Vertex),	&buff.getVerts()->col);

			glDrawArrays(GL_QUADS, 0, buff.getCount());
			}
		}
	}

#endif
