/*
 * button.cpp
 *
 *  Created on: 04-04-2013
 *      Author: crm
 */

#include "button.h"

#include <ctime>

#include "../render.h"

#include "log.h"

namespace UI
	{
	void Button::init(Rect r, const std::string& name)
		{
		Base::init(r);

		spr.setSprite(name);

		pressed=0u;
		}

	void Button::update(float dt)
		{
		spr.update(dt);

		if(pressed>0u && pressed<(unsigned)time(NULL))
			{
			pressed=0u;
			spr.setAnim(0u);
			}
		}

	void Button::print()
		{
		//Render::print(spr, rect.x, rect.y, 0);
		}


	void Button::click(int x, int y)
		{
		if(!rect.isIn(x, y))
			return;

		pressed=time(NULL);
		spr.setAnim(1u);

		Base::click(x, y);
		}
	}
