/*
 * panel.cpp
 *
 *  Created on: 04-04-2013
 *      Author: crm
 */

#include "panel.h"

#include "log.h"

namespace UI
	{
	void Panel::init(Rect r)
		{
		clear();

		Base::init(r);
		}

	void Panel::update(float dt)
		{
		for(std::list<Base *>::iterator it=items.begin(); it!=items.end(); ++it)
			(*it)->update(dt);
		}

	void Panel::print()
		{
		for(std::list<Base *>::iterator it=items.begin(); it!=items.end(); ++it)
			(*it)->print();
		}

	void Panel::clear()
		{
		items.clear();
		}


	void Panel::addItem(Base *item)
		{
		items.push_back(item);
		}

	void Panel::click(int x, int y)
		{
		if(!rect.isIn(x, y))
			return;

		for(std::list<Base *>::iterator it=items.begin(); it!=items.end(); ++it)
			if((*it)->isIn(x, y))
				(*it)->click(x, y);
		}

	void Panel::hover(int x, int y)
		{
		for(std::list<Base *>::iterator it=items.begin(); it!=items.end(); ++it)
			if((*it)->isIn(x, y))
				(*it)->hover(x, y);
		}
	}
