/*
 * lua_misc.cpp
 *
 *  Created on: 06-05-2013
 *      Author: crm
 */

#include "lua_misc.h"

#ifdef WIN32
	#define WINDOWS
#else
	#ifdef WIN64
		#define WINDOWS
	#else
		#define LINUX
	#endif
#endif

extern "C"
	{
	#ifdef WINDOWS
		#include <lua/lua.h>
		#include <lua/lualib.h>
		#include <lua/lauxlib.h>
	#else
		#include <lua.h>
		#include <lualib.h>
		#include <lauxlib.h>
	#endif
	}

#include <sstream>

#include "parser.h"

std::string luaGetTypeName(lua_State *L, int i)
	{
	int t=lua_type(L, i);

	std::stringstream ss;

	switch(t)
		{
		case LUA_TNUMBER:
			ss << "[Number: " << lua_tonumber(L, i) << "]";
		break;

		case LUA_TSTRING:
			ss << "[String: \"" << lua_tostring(L, i) << "\"]";
		break;

		case LUA_TBOOLEAN:
			ss << "[Boolean: " << (lua_toboolean(L, i)?"true":"false") << "]";
		break;

		default:
			ss << "[Type: " << lua_typename(L, t) << "]";// << "[" << t << ": " << LUA_TNUMBER << " " << LUA_TSTRING << " " << LUA_TBOOLEAN << "]";
		break;
		}

	return ss.str();
	}

void luaDump(lua_State *L)
	{
	//
	}

void luaStackDump(lua_State *L)
	{
	const int size=lua_gettop(L);

	printf("LUA: Stack: ");
	for(int i=1; i<=size; ++i)
		{
		printf("%s ", luaGetTypeName(L, i).c_str());
		}
	printf("\n");

	return;
	int i;
	int top = lua_gettop(L);
	for (i = 1; i <= top; i++)
		{  /* repeat for each level */
		int t = lua_type(L, i);
		switch (t)
			{
			case LUA_TSTRING:  /* strings */
			printf("`%s'", lua_tostring(L, i));
			break;

			case LUA_TBOOLEAN:  /* booleans */
			printf(lua_toboolean(L, i) ? "true" : "false");
			break;

			case LUA_TNUMBER:  /* numbers */
			printf("%g", lua_tonumber(L, i));
			break;

			default:  /* other values */
			printf("%s", lua_typename(L, t));
			break;
			}
		printf("  ");  /* put a separator */
		}
	printf("\n");  /* end the listing */
	}

void luaCreateTableStack(lua_State *L, const std::string& path)
	{
	Parser pars(path, ".");

	if(pars.count()<1)
		return;

	luaStackDump(L);
	lua_settop(L, 0);
	luaStackDump(L);
	lua_pushglobaltable(L);
	luaStackDump(L);

	for(int i=0; i<pars.count(); ++i)
		{
		std::string name=pars[i];

		luaGetTable(L, name);
		break;
		}
	}

void luaGetTable(lua_State *L, const std::string& name)
	{
	lua_pushstring(L, name.c_str());
	luaStackDump(L);

	lua_gettable(L, -2);

	luaStackDump(L);
	return;

	// Nie ma tabeli, zrob
	if(lua_isnil(L, -1))
		{
		lua_pop(L, -1);

		lua_pushstring(L, name.c_str());
		lua_newtable(L);
		lua_settable(L, -3);
		lua_settop(L, -1);
		}
	else
		{
		//lua_settop(L, -1);// Tabela istnieje, waaai~
		}
	}
